package tech.nevets.signaturecardgen;

import com.google.gson.Gson;
import com.google.gson.JsonObject;
import com.google.gson.JsonSyntaxException;
import spark.Request;
import spark.Response;
import spark.Route;

import java.io.IOException;

public class GenerateRoute implements Route {
    @Override
    public Object handle(Request req, Response res) {
    Card card;
        String id = req.queryParams("id");
        if (!id.isEmpty()) {
            card = Card.CARD_SESSIONS.get(id);
            if (card == null) {
                res.type("text/plain");
                res.status(404);
                return "Card with that id not found.";
            }
        } else {
            JsonObject data;
            try {
                data = new Gson().fromJson(req.body(), JsonObject.class);
            } catch (JsonSyntaxException e) {
                res.status(422);
                return "Not valid json: " + e.getMessage();
            }
            System.out.println("JSON Data: " + data.toString());
            card = new Card(data);
        }
        card.renderImage();

        res.type("image/png");
           try {
            res.status(200);
            return card.toByteArray();
        } catch (IOException e) {
            res.status(500);
            return "Error getting image stream: " + e.getMessage();
        }
    }
}
